diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv4-interface-address.h ns-3.44/src/internet/model/ipv4-interface-address.h
--- ns-3.43/src/internet/model/ipv4-interface-address.h	2024-10-09 16:41:09.884656000 -0700
+++ ns-3.44/src/internet/model/ipv4-interface-address.h	2025-03-09 16:55:49.395371200 -0700
@@ -17,10 +17,10 @@
 {
 
 /**
- * \ingroup address
- * \ingroup ipv4
+ * @ingroup address
+ * @ingroup ipv4
  *
- * \brief a class to store IPv4 address information on an interface
+ * @brief a class to store IPv4 address information on an interface
  *
  * Corresponds to Linux struct in_ifaddr.  A list of these addresses
  * is stored in Ipv4Interface.  This class is modelled after how current
@@ -34,8 +34,8 @@
 {
   public:
     /**
-     * \enum InterfaceAddressScope_e
-     * \brief Address scope.
+     * @enum InterfaceAddressScope_e
+     * @brief Address scope.
      */
     enum InterfaceAddressScope_e
     {
@@ -47,109 +47,109 @@
     Ipv4InterfaceAddress();
 
     /**
-     * \brief Configure local address, mask and broadcast address
-     * \param local the local address
-     * \param mask the network mask
+     * @brief Configure local address, mask and broadcast address
+     * @param local the local address
+     * @param mask the network mask
      */
     Ipv4InterfaceAddress(Ipv4Address local, Ipv4Mask mask);
     /**
      * Copy constructor
-     * \param o the object to copy
+     * @param o the object to copy
      */
     Ipv4InterfaceAddress(const Ipv4InterfaceAddress& o);
 
     /**
-     * \brief Set local address
-     * \param local the address
+     * @brief Set local address
+     * @param local the address
      *
-     * \note Functionally identical to `Ipv4InterfaceAddress::SetAddress`.
+     * @note Functionally identical to `Ipv4InterfaceAddress::SetAddress`.
      *       The method corresponds to the linux variable in_ifaddr.ifa_local
      *       `Ipv4InterfaceAddress::SetAddress` is to be preferred.
      */
     void SetLocal(Ipv4Address local);
 
     /**
-     * \brief Set local address
-     * \param address the address
+     * @brief Set local address
+     * @param address the address
      *
-     * \note Functially identical to `Ipv4InterfaceAddress::SetLocal`.
+     * @note Functially identical to `Ipv4InterfaceAddress::SetLocal`.
      *       This function is consistent with `Ipv6InterfaceAddress::SetAddress`.
      */
     void SetAddress(Ipv4Address address);
 
     /**
-     * \brief Get the local address
-     * \returns the local address
+     * @brief Get the local address
+     * @returns the local address
      *
-     * \note Functionally identical to `Ipv4InterfaceAddress::GetAddress`.
+     * @note Functionally identical to `Ipv4InterfaceAddress::GetAddress`.
      *       The method corresponds to the linux variable in_ifaddr.ifa_local
      *       `Ipv4InterfaceAddress::GetAddress` is to be preferred.
      */
     Ipv4Address GetLocal() const;
 
     /**
-     * \brief Get the local address
-     * \returns the local address
+     * @brief Get the local address
+     * @returns the local address
      *
-     * \note Functially identical to `Ipv4InterfaceAddress::GetLocal`.
+     * @note Functially identical to `Ipv4InterfaceAddress::GetLocal`.
      *       This function is consistent with `Ipv6InterfaceAddress::GetAddress`.
      */
     Ipv4Address GetAddress() const;
 
     /**
-     * \brief Set the network mask
-     * \param mask the network mask
+     * @brief Set the network mask
+     * @param mask the network mask
      */
     void SetMask(Ipv4Mask mask);
     /**
-     * \brief Get the network mask
-     * \returns the network mask
+     * @brief Get the network mask
+     * @returns the network mask
      */
     Ipv4Mask GetMask() const;
     /**
-     * \brief Set the broadcast address
-     * \param broadcast the broadcast address
+     * @brief Set the broadcast address
+     * @param broadcast the broadcast address
      */
     void SetBroadcast(Ipv4Address broadcast);
     /**
-     * \brief Get the broadcast address
-     * \returns the broadcast address
+     * @brief Get the broadcast address
+     * @returns the broadcast address
      */
     Ipv4Address GetBroadcast() const;
 
     /**
-     * \brief Set the scope.
-     * \param scope the scope of address
+     * @brief Set the scope.
+     * @param scope the scope of address
      */
     void SetScope(Ipv4InterfaceAddress::InterfaceAddressScope_e scope);
 
     /**
-     * \brief Get address scope.
-     * \return scope
+     * @brief Get address scope.
+     * @return scope
      */
     Ipv4InterfaceAddress::InterfaceAddressScope_e GetScope() const;
 
     /**
-     * \brief Checks if the address is in the same subnet.
-     * \param b the address to check
-     * \return true if the address is in the same subnet.
+     * @brief Checks if the address is in the same subnet.
+     * @param b the address to check
+     * @return true if the address is in the same subnet.
      */
     bool IsInSameSubnet(const Ipv4Address b) const;
 
     /**
-     * \brief Check if the address is a secondary address
+     * @brief Check if the address is a secondary address
      *
      * Secondary address is used for multihoming
-     * \returns true if the address is secondary
+     * @returns true if the address is secondary
      */
     bool IsSecondary() const;
 
     /**
-     * \brief Make the address secondary (used for multihoming)
+     * @brief Make the address secondary (used for multihoming)
      */
     void SetSecondary();
     /**
-     * \brief Make the address primary
+     * @brief Make the address primary
      */
     void SetPrimary();
 
@@ -164,30 +164,30 @@
     bool m_secondary;                //!< For use in multihoming
 
     /**
-     * \brief Equal to operator.
+     * @brief Equal to operator.
      *
-     * \param a the first operand
-     * \param b the first operand
-     * \returns true if the operands are equal
+     * @param a the first operand
+     * @param b the first operand
+     * @returns true if the operands are equal
      */
     friend bool operator==(const Ipv4InterfaceAddress& a, const Ipv4InterfaceAddress& b);
 
     /**
-     * \brief Not equal to operator.
+     * @brief Not equal to operator.
      *
-     * \param a the first operand
-     * \param b the first operand
-     * \returns true if the operands are not equal
+     * @param a the first operand
+     * @param b the first operand
+     * @returns true if the operands are not equal
      */
     friend bool operator!=(const Ipv4InterfaceAddress& a, const Ipv4InterfaceAddress& b);
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the reference to the output stream
- * \param addr the Ipv4InterfaceAddress
- * \returns the reference to the output stream
+ * @param os the reference to the output stream
+ * @param addr the Ipv4InterfaceAddress
+ * @returns the reference to the output stream
  */
 std::ostream& operator<<(std::ostream& os, const Ipv4InterfaceAddress& addr);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv4-interface.cc ns-3.44/src/internet/model/ipv4-interface.cc
--- ns-3.43/src/internet/model/ipv4-interface.cc	2024-10-09 16:41:09.884656000 -0700
+++ ns-3.44/src/internet/model/ipv4-interface.cc	2025-03-09 16:55:49.395371200 -0700
@@ -211,7 +211,7 @@
     // traffic control layer
     if (DynamicCast<LoopbackNetDevice>(m_device))
     {
-        /// \todo additional checks needed here (such as whether multicast
+        /// @todo additional checks needed here (such as whether multicast
         /// goes to loopback)?
         p->AddHeader(hdr);
         m_device->Send(p, m_device->GetBroadcast(), Ipv4L3Protocol::PROT_NUMBER);
@@ -323,24 +323,22 @@
 Ipv4Interface::GetAddress(uint32_t index) const
 {
     NS_LOG_FUNCTION(this << index);
-    if (index < m_ifaddrs.size())
+    if (index >= m_ifaddrs.size())
     {
-        uint32_t tmp = 0;
-        for (auto i = m_ifaddrs.begin(); i != m_ifaddrs.end(); i++)
-        {
-            if (tmp == index)
-            {
-                return *i;
-            }
-            ++tmp;
-        }
+        NS_FATAL_ERROR("index " << index << " out of bounds");
     }
-    else
+
+    uint32_t tmp = 0;
+    for (auto i = m_ifaddrs.begin(); i != m_ifaddrs.end(); i++)
     {
-        NS_FATAL_ERROR("index " << index << " out of bounds");
+        if (tmp == index)
+        {
+            return *i;
+        }
+        ++tmp;
     }
-    Ipv4InterfaceAddress addr;
-    return addr; // quiet compiler
+
+    return {}; // quiet compiler
 }
 
 Ipv4InterfaceAddress
@@ -351,14 +349,16 @@
     {
         NS_FATAL_ERROR("Bug in Ipv4Interface::RemoveAddress");
     }
-    auto i = m_ifaddrs.begin();
+
     uint32_t tmp = 0;
-    while (i != m_ifaddrs.end())
+    for (auto it = m_ifaddrs.begin(); it != m_ifaddrs.end(); it++)
     {
         if (tmp == index)
         {
-            Ipv4InterfaceAddress addr = *i;
-            m_ifaddrs.erase(i);
+            // NOLINTNEXTLINE(performance-unnecessary-copy-initialization)
+            Ipv4InterfaceAddress addr = *it;
+
+            m_ifaddrs.erase(it);
             if (!m_removeAddressCallback.IsNull())
             {
                 m_removeAddressCallback(this, addr);
@@ -366,11 +366,9 @@
             return addr;
         }
         ++tmp;
-        ++i;
     }
     NS_FATAL_ERROR("Address " << index << " not found");
-    Ipv4InterfaceAddress addr;
-    return addr; // quiet compiler
+    return {}; // quiet compiler
 }
 
 Ipv4InterfaceAddress
@@ -388,7 +386,9 @@
     {
         if ((*it).GetLocal() == address)
         {
+            // NOLINTNEXTLINE(performance-unnecessary-copy-initialization)
             Ipv4InterfaceAddress ifAddr = *it;
+
             m_ifaddrs.erase(it);
             if (!m_removeAddressCallback.IsNull())
             {
@@ -397,7 +397,7 @@
             return ifAddr;
         }
     }
-    return Ipv4InterfaceAddress();
+    return {};
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv4-interface.h ns-3.44/src/internet/model/ipv4-interface.h
--- ns-3.43/src/internet/model/ipv4-interface.h	2024-10-09 16:41:09.884656000 -0700
+++ ns-3.44/src/internet/model/ipv4-interface.h	2025-03-09 16:55:49.395371200 -0700
@@ -28,9 +28,9 @@
 class TrafficControlLayer;
 
 /**
- * \ingroup ipv4
+ * @ingroup ipv4
  *
- * \brief The IPv4 representation of a network interface
+ * @brief The IPv4 representation of a network interface
  *
  * This class roughly corresponds to the struct in_device
  * of Linux; the main purpose is to provide address-family
@@ -44,8 +44,8 @@
 {
   public:
     /**
-     * \brief Get the type ID
-     * \return type ID
+     * @brief Get the type ID
+     * @return type ID
      */
     static TypeId GetTypeId();
 
@@ -57,38 +57,38 @@
     Ipv4Interface& operator=(const Ipv4Interface&) = delete;
 
     /**
-     * \brief Set node associated with interface.
-     * \param node node
+     * @brief Set node associated with interface.
+     * @param node node
      */
     void SetNode(Ptr<Node> node);
     /**
-     * \brief Set the NetDevice.
-     * \param device NetDevice
+     * @brief Set the NetDevice.
+     * @param device NetDevice
      */
     void SetDevice(Ptr<NetDevice> device);
     /**
-     * \brief Set the TrafficControlLayer.
-     * \param tc TrafficControlLayer object
+     * @brief Set the TrafficControlLayer.
+     * @param tc TrafficControlLayer object
      */
     void SetTrafficControl(Ptr<TrafficControlLayer> tc);
     /**
-     * \brief Set ARP cache used by this interface
-     * \param arpCache the ARP cache
+     * @brief Set ARP cache used by this interface
+     * @param arpCache the ARP cache
      */
     void SetArpCache(Ptr<ArpCache> arpCache);
 
     /**
-     * \returns the underlying NetDevice. This method cannot return zero.
+     * @returns the underlying NetDevice. This method cannot return zero.
      */
     Ptr<NetDevice> GetDevice() const;
 
     /**
-     * \return ARP cache used by this interface
+     * @return ARP cache used by this interface
      */
     Ptr<ArpCache> GetArpCache() const;
 
     /**
-     * \param metric configured routing metric (cost) of this interface
+     * @param metric configured routing metric (cost) of this interface
      *
      * Note:  This is synonymous to the Metric value that ifconfig prints
      * out.  It is used by ns-3 global routing, but other routing daemons
@@ -97,7 +97,7 @@
     void SetMetric(uint16_t metric);
 
     /**
-     * \returns configured routing metric (cost) of this interface
+     * @returns configured routing metric (cost) of this interface
      *
      * Note:  This is synonymous to the Metric value that ifconfig prints
      * out.  It is used by ns-3 global routing, but other routing daemons
@@ -111,12 +111,12 @@
      * (where the device may be down but IP interface state is still up).
      */
     /**
-     * \returns true if this interface is enabled, false otherwise.
+     * @returns true if this interface is enabled, false otherwise.
      */
     bool IsUp() const;
 
     /**
-     * \returns true if this interface is disabled, false otherwise.
+     * @returns true if this interface is disabled, false otherwise.
      */
     bool IsDown() const;
 
@@ -131,19 +131,19 @@
     void SetDown();
 
     /**
-     * \returns true if this interface is enabled for IP forwarding of input datagrams
+     * @returns true if this interface is enabled for IP forwarding of input datagrams
      */
     bool IsForwarding() const;
 
     /**
-     * \param val Whether to enable or disable IP forwarding for input datagrams
+     * @param val Whether to enable or disable IP forwarding for input datagrams
      */
     void SetForwarding(bool val);
 
     /**
-     * \param p packet to send
-     * \param hdr IPv4 header
-     * \param dest next hop address of packet.
+     * @param p packet to send
+     * @param hdr IPv4 header
+     * @param dest next hop address of packet.
      *
      * This method will eventually call the private
      * SendTo method which must be implemented by subclasses.
@@ -151,33 +151,33 @@
     void Send(Ptr<Packet> p, const Ipv4Header& hdr, Ipv4Address dest);
 
     /**
-     * \param address The Ipv4InterfaceAddress to add to the interface
-     * \returns true if succeeded
+     * @param address The Ipv4InterfaceAddress to add to the interface
+     * @returns true if succeeded
      */
     bool AddAddress(Ipv4InterfaceAddress address);
 
     /**
-     * \param index Index of Ipv4InterfaceAddress to return
-     * \returns The Ipv4InterfaceAddress address whose index is i
+     * @param index Index of Ipv4InterfaceAddress to return
+     * @returns The Ipv4InterfaceAddress address whose index is i
      */
     Ipv4InterfaceAddress GetAddress(uint32_t index) const;
 
     /**
-     * \returns the number of Ipv4InterfaceAddress stored on this interface
+     * @returns the number of Ipv4InterfaceAddress stored on this interface
      */
     uint32_t GetNAddresses() const;
 
     /**
-     * \param index Index of Ipv4InterfaceAddress to remove
-     * \returns The Ipv4InterfaceAddress address whose index is index
+     * @param index Index of Ipv4InterfaceAddress to remove
+     * @returns The Ipv4InterfaceAddress address whose index is index
      */
     Ipv4InterfaceAddress RemoveAddress(uint32_t index);
 
     /**
-     * \brief Remove the given Ipv4 address from the interface.
-     * \param address The Ipv4 address to remove
-     * \returns The removed Ipv4 interface address
-     * \returns The null interface address if the interface did not contain the
+     * @brief Remove the given Ipv4 address from the interface.
+     * @param address The Ipv4 address to remove
+     * @returns The removed Ipv4 interface address
+     * @returns The null interface address if the interface did not contain the
      * address or if loopback address was passed as argument
      */
     Ipv4InterfaceAddress RemoveAddress(Ipv4Address address);
@@ -187,7 +187,7 @@
      * auto-generated Arp cache and it allow the neighbor cache helper to update
      * neighbor's Arp cache
      *
-     * \param removeAddressCallback Callback when remove an address.
+     * @param removeAddressCallback Callback when remove an address.
      */
     void RemoveAddressCallback(
         Callback<void, Ptr<Ipv4Interface>, Ipv4InterfaceAddress> removeAddressCallback);
@@ -197,7 +197,7 @@
      * auto-generated Arp cache and it allow the neighbor cache helper to update
      * neighbor's Arp cache
      *
-     * \param addAddressCallback Callback when remove an address.
+     * @param addAddressCallback Callback when remove an address.
      */
     void AddAddressCallback(
         Callback<void, Ptr<Ipv4Interface>, Ipv4InterfaceAddress> addAddressCallback);
@@ -207,22 +207,22 @@
 
   private:
     /**
-     * \brief Initialize interface.
+     * @brief Initialize interface.
      */
     void DoSetup();
 
     /**
-     * \brief Container for the Ipv4InterfaceAddresses.
+     * @brief Container for the Ipv4InterfaceAddresses.
      */
     typedef std::list<Ipv4InterfaceAddress> Ipv4InterfaceAddressList;
 
     /**
-     * \brief Container Iterator for the Ipv4InterfaceAddresses.
+     * @brief Container Iterator for the Ipv4InterfaceAddresses.
      */
     typedef std::list<Ipv4InterfaceAddress>::const_iterator Ipv4InterfaceAddressListCI;
 
     /**
-     * \brief Const Container Iterator for the Ipv4InterfaceAddresses.
+     * @brief Const Container Iterator for the Ipv4InterfaceAddresses.
      */
     typedef std::list<Ipv4InterfaceAddress>::iterator Ipv4InterfaceAddressListI;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/internet/model/ipv4-l3-protocol.cc ns-3.44/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.43/src/internet/model/ipv4-l3-protocol.cc	2024-10-09 16:41:09.884656000 -0700
+++ ns-3.44/src/internet/model/ipv4-l3-protocol.cc	2025-03-09 16:55:49.395371200 -0700
@@ -36,8 +36,6 @@
 
 NS_LOG_COMPONENT_DEFINE("Ipv4L3Protocol");
 
-const uint16_t Ipv4L3Protocol::PROT_NUMBER = 0x0800;
-
 NS_OBJECT_ENSURE_REGISTERED(Ipv4L3Protocol);
 
 TypeId
@@ -1017,13 +1015,13 @@
 
         Ptr<Packet> packet = p->Copy();
         Ipv4Header ipHeader = header;
-        ipHeader.SetTtl(header.GetTtl() - 1);
-        if (ipHeader.GetTtl() == 0)
+        if (ipHeader.GetTtl() <= 1)
         {
             NS_LOG_WARN("TTL exceeded.  Drop.");
             m_dropTrace(header, packet, DROP_TTL_EXPIRED, this, interface);
             return;
         }
+        ipHeader.SetTtl(header.GetTtl() - 1);
         NS_LOG_LOGIC("Forward multicast via interface " << interface);
         Ptr<Ipv4Route> rtentry = Create<Ipv4Route>();
         rtentry->SetSource(ipHeader.GetSource());
@@ -1046,8 +1044,7 @@
     Ipv4Header ipHeader = header;
     Ptr<Packet> packet = p->Copy();
     int32_t interface = GetInterfaceForDevice(rtentry->GetOutputDevice());
-    ipHeader.SetTtl(ipHeader.GetTtl() - 1);
-    if (ipHeader.GetTtl() == 0)
+    if (ipHeader.GetTtl() <= 1)
     {
         // Do not reply to multicast/broadcast IP address
         if (!ipHeader.GetDestination().IsBroadcast() && !ipHeader.GetDestination().IsMulticast())
@@ -1059,6 +1056,7 @@
         m_dropTrace(header, packet, DROP_TTL_EXPIRED, this, interface);
         return;
     }
+    ipHeader.SetTtl(ipHeader.GetTtl() - 1);
     // in case the packet still has a priority tag attached, remove it
     SocketPriorityTag priorityTag;
     packet->RemovePacketTag(priorityTag);
